Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/il/ip_client.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,11 +27,11 @@
  */
 
-/** @addtogroup ip
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  IP client interface implementation.
- *  @see ip_client.h
+ * IP client interface implementation.
+ * @see ip_client.h
  */
 
@@ -40,65 +40,121 @@
 
 #include <ip_client.h>
-#include <socket_errno.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
+#include <packet_client.h>
 #include <ip_header.h>
 
-size_t ip_client_header_length(packet_t packet){
+#include <net/packet.h>
+
+/** Returns the IP header length.
+ *
+ * @param[in] packet	The packet.
+ * @returns		The IP header length in bytes.
+ * @returns		Zero if there is no IP header.
+ */
+size_t ip_client_header_length(packet_t packet)
+{
 	ip_header_ref header;
 
 	header = (ip_header_ref) packet_get_data(packet);
-	if((! header)
-		|| (packet_get_data_length(packet) < sizeof(ip_header_t))){
+	if (!header || (packet_get_data_length(packet) < sizeof(ip_header_t)))
 		return 0;
-	}
+
 	return IP_HEADER_LENGTH(header);
 }
 
-int ip_client_get_pseudo_header(ip_protocol_t protocol, struct sockaddr * src, socklen_t srclen, struct sockaddr * dest, socklen_t destlen, size_t data_length, void **header, size_t * headerlen){
+/** Constructs the IPv4 pseudo header.
+ *
+ * @param[in] protocol	The transport protocol.
+ * @param[in] src	The source address.
+ * @param[in] srclen	The source address length.
+ * @param[in] dest	The destination address.
+ * @param[in] destlen	The destination address length.
+ * @param[in] data_length The data length to be set.
+ * @param[out] header	The constructed IPv4 pseudo header.
+ * @param[out] headerlen The length of the IP pseudo header in bytes.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the header and/or the headerlen parameter is
+ *			NULL.
+ * @returns		EINVAL if the source address and/or the destination
+ *			address parameter is NULL.
+ * @returns		EINVAL if the source address length is less than struct
+ *			sockaddr length.
+ * @returns		EINVAL if the source address length differs from the
+ *			destination address length.
+ * @returns		EINVAL if the source address family differs from the
+ *			destination family.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int
+ip_client_get_pseudo_header(ip_protocol_t protocol, struct sockaddr *src,
+    socklen_t srclen, struct sockaddr *dest, socklen_t destlen,
+    size_t data_length, void **header, size_t *headerlen)
+{
 	ipv4_pseudo_header_ref header_in;
-	struct sockaddr_in * address_in;
-
-	if(!(header && headerlen)){
+	struct sockaddr_in *address_in;
+
+	if (!header || !headerlen)
 		return EBADMEM;
-	}
-	if(!(src && dest && (srclen > 0) && ((size_t) srclen >= sizeof(struct sockaddr)) && (srclen == destlen) && (src->sa_family == dest->sa_family))){
+
+	if (!src || !dest || srclen <= 0 ||
+	    (((size_t) srclen < sizeof(struct sockaddr))) ||
+	    (srclen != destlen) || (src->sa_family != dest->sa_family)) {
 		return EINVAL;
 	}
 
-	switch(src->sa_family){
-		case AF_INET:
-			if(srclen != sizeof(struct sockaddr_in)){
-				return EINVAL;
-			}
-			*headerlen = sizeof(*header_in);
-			header_in = (ipv4_pseudo_header_ref) malloc(*headerlen);
-			if(! header_in){
-				return ENOMEM;
-			}
-			bzero(header_in, * headerlen);
-			address_in = (struct sockaddr_in *) dest;
-			header_in->destination_address = address_in->sin_addr.s_addr;
-			address_in = (struct sockaddr_in *) src;
-			header_in->source_address = address_in->sin_addr.s_addr;
-			header_in->protocol = protocol;
-			header_in->data_length = htons(data_length);
-			*header = header_in;
-			return EOK;
-		// TODO IPv6
-/*		case AF_INET6:
-			if(addrlen != sizeof(struct sockaddr_in6)){
-				return EINVAL;
-			}
-			address_in6 = (struct sockaddr_in6 *) addr;
-			return EOK;
-*/		default:
-			return EAFNOSUPPORT;
-	}
-}
-
-int ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl, ip_tos_t tos, int dont_fragment, size_t ipopt_length){
+	switch (src->sa_family) {
+	case AF_INET:
+		if (srclen != sizeof(struct sockaddr_in))
+			return EINVAL;
+		
+		*headerlen = sizeof(*header_in);
+		header_in = (ipv4_pseudo_header_ref) malloc(*headerlen);
+		if (!header_in)
+			return ENOMEM;
+
+		bzero(header_in, *headerlen);
+		address_in = (struct sockaddr_in *) dest;
+		header_in->destination_address = address_in->sin_addr.s_addr;
+		address_in = (struct sockaddr_in *) src;
+		header_in->source_address = address_in->sin_addr.s_addr;
+		header_in->protocol = protocol;
+		header_in->data_length = htons(data_length);
+		*header = header_in;
+		return EOK;
+
+	// TODO IPv6
+/*	case AF_INET6:
+		if (addrlen != sizeof(struct sockaddr_in6))
+			return EINVAL;
+
+		address_in6 = (struct sockaddr_in6 *) addr;
+		return EOK;
+*/
+
+	default:
+		return EAFNOSUPPORT;
+	}
+}
+
+/** Prepares the packet to be transfered via IP.
+ *
+ * The IP header is prefixed.
+ *
+ * @param[in,out] packet The packet to be prepared.
+ * @param[in] protocol	The transport protocol.
+ * @param[in] ttl	The time to live counter. The IPDEFTTL is set if zero.
+ * @param[in] tos	The type of service.
+ * @param[in] dont_fragment The value indicating whether fragmentation is
+ *			disabled.
+ * @param[in] ipopt_length The prefixed IP options length in bytes.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left in the packet.
+ */
+int
+ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl,
+    ip_tos_t tos, int dont_fragment, size_t ipopt_length)
+{
 	ip_header_ref header;
-	uint8_t * data;
+	uint8_t *data;
 	size_t padding;
 
@@ -106,5 +162,5 @@
 	// multiple of 4 bytes
 	padding =  ipopt_length % 4;
-	if(padding){
+	if (padding) {
 		padding = 4 - padding;
 		ipopt_length += padding;
@@ -113,68 +169,93 @@
 	// prefix the header
 	data = (uint8_t *) packet_prefix(packet, sizeof(ip_header_t) + padding);
-	if(! data){
+	if (!data)
 		return ENOMEM;
-	}
 
 	// add the padding
-	while(padding --){
+	while (padding--)
 		data[sizeof(ip_header_t) + padding] = IPOPT_NOOP;
-	}
 
 	// set the header
 	header = (ip_header_ref) data;
-	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) + ipopt_length);
-	header->ttl = (ttl ? ttl : IPDEFTTL); //(((ttl) <= MAXTTL) ? ttl : MAXTTL) : IPDEFTTL;
+	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) +
+	    ipopt_length);
+	header->ttl = (ttl ? ttl : IPDEFTTL);
 	header->tos = tos;
 	header->protocol = protocol;
 
-	if(dont_fragment){
+	if (dont_fragment)
 		header->flags = IPFLAG_DONT_FRAGMENT;
-	}
+
 	return EOK;
 }
 
-int ip_client_process_packet(packet_t packet, ip_protocol_t * protocol, ip_ttl_t * ttl, ip_tos_t * tos, int * dont_fragment, size_t * ipopt_length){
+/** Processes the received IP packet.
+ *
+ * Fills set header fields.
+ * Returns the prefixed IP header length.
+ *
+ * @param[in] packet	The received packet.
+ * @param[out] protocol	The transport protocol. May be NULL if not desired.
+ * @param[out] ttl	The time to live counter. May be NULL if not desired.
+ * @param[out] tos	The type of service. May be NULL if not desired.
+ * @param[out] dont_fragment The value indicating whether the fragmentation is
+ *			disabled. May be NULL if not desired.
+ * @param[out] ipopt_length The IP options length in bytes. May be NULL if not
+ *			desired.
+ * @returns		The prefixed IP header length in bytes on success.
+ * @returns		ENOMEM if the packet is too short to contain the IP
+ *			header.
+ */
+int
+ip_client_process_packet(packet_t packet, ip_protocol_t *protocol,
+    ip_ttl_t *ttl, ip_tos_t *tos, int *dont_fragment, size_t *ipopt_length)
+{
 	ip_header_ref header;
 
 	header = (ip_header_ref) packet_get_data(packet);
-	if((! header)
-		|| (packet_get_data_length(packet) < sizeof(ip_header_t))){
+	if (!header || (packet_get_data_length(packet) < sizeof(ip_header_t)))
 		return ENOMEM;
-	}
-
-	if(protocol){
+
+	if (protocol)
 		*protocol = header->protocol;
-	}
-	if(ttl){
+	if (ttl)
 		*ttl = header->ttl;
-	}
-	if(tos){
+	if (tos)
 		*tos = header->tos;
-	}
-	if(dont_fragment){
-		*dont_fragment = header->flags &IPFLAG_DONT_FRAGMENT;
-	}
-	if(ipopt_length){
+	if (dont_fragment)
+		*dont_fragment = header->flags & IPFLAG_DONT_FRAGMENT;
+	if (ipopt_length) {
 		*ipopt_length = IP_HEADER_LENGTH(header) - sizeof(ip_header_t);
 		return sizeof(ip_header_t);
-	}else{
+	} else {
 		return IP_HEADER_LENGTH(header);
 	}
 }
 
-int ip_client_set_pseudo_header_data_length(void *header, size_t headerlen, size_t data_length){
+/** Updates the IPv4 pseudo header data length field.
+ *
+ * @param[in,out] header The IPv4 pseudo header to be updated.
+ * @param[in] headerlen	The length of the IP pseudo header in bytes.
+ * @param[in] data_length The data length to be set.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the header parameter is NULL.
+ * @returns		EINVAL if the headerlen parameter is not IPv4 pseudo
+ *			header length.
+ */
+int
+ip_client_set_pseudo_header_data_length(void *header, size_t headerlen,
+    size_t data_length)
+{
 	ipv4_pseudo_header_ref header_in;
 
-	if(! header){
+	if (!header)
 		return EBADMEM;
-	}
-
-	if(headerlen == sizeof(ipv4_pseudo_header_t)){
+
+	if (headerlen == sizeof(ipv4_pseudo_header_t)) {
 		header_in = (ipv4_pseudo_header_ref) header;
 		header_in->data_length = htons(data_length);
 		return EOK;
 	// TODO IPv6
-	}else{
+	} else {
 		return EINVAL;
 	}
Index: uspace/lib/net/il/ip_remote.c
===================================================================
--- uspace/lib/net/il/ip_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/il/ip_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,15 +40,16 @@
  */
 
+#include <ip_remote.h>
+#include <ip_interface.h>
+#include <packet_client.h>
+#include <generic.h>
+
 #include <ipc/services.h>
-
-#include <net_messages.h>
-#include <net_modules.h>
-#include <net_device.h>
-#include <inet.h>
-#include <ip_interface.h>
-#include <packet/packet_client.h>
-#include <il_messages.h>
-#include <ip_messages.h>
-#include <ip_remote.h>
+#include <ipc/il.h>
+#include <ipc/ip.h>
+
+#include <net/modules.h>
+#include <net/device.h>
+#include <net/inet.h>
 
 /** Add a route to the device routing table.
@@ -72,5 +73,5 @@
 
 int ip_bind_service(services_t service, int protocol, services_t me,
-    async_client_conn_t receiver, tl_received_msg_t tl_received_msg)
+    async_client_conn_t receiver)
 {
 	return (int) bind_service(service, (ipcarg_t) protocol, me, service,
@@ -127,5 +128,5 @@
 		return EINVAL;
 	
-	if ((!device_id) || (header) || (headerlen))
+	if ((!device_id) || (!header) || (!headerlen))
 		return EBADMEM;
 	
Index: uspace/lib/net/include/adt/module_map.h
===================================================================
--- uspace/lib/net/include/adt/module_map.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/adt/module_map.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,94 +27,58 @@
  */
 
-/** @addtogroup net
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  Character string to module map.
+ * Character string to module map.
  */
 
-#ifndef __NET_MODULES_MAP_H__
-#define __NET_MODULES_MAP_H__
+#ifndef LIBNET_MODULES_MAP_H_
+#define LIBNET_MODULES_MAP_H_
 
 #include <task.h>
-
 #include <ipc/services.h>
-
-#include <net_modules.h>
-
+#include <net/modules.h>
 #include <adt/generic_char_map.h>
 
 /** Type definition of the module structure.
- *  @see module_struct
+ * @see module_struct
  */
-typedef struct module_struct	module_t;
+typedef struct module_struct module_t;
 
 /** Type definition of the module structure pointer.
- *  @see module_struct
+ * @see module_struct
  */
-typedef module_t *				module_ref;
+typedef module_t *module_ref;
 
 /** Module map.
- *  Sorted by module names.
- *  @see generic_char_map.h
+ * Sorted by module names.
+ * @see generic_char_map.h
  */
 GENERIC_CHAR_MAP_DECLARE(modules, module_t)
 
-/** Module structure.
- */
-struct	module_struct{
-	/** Module task identifier if running.
-	 */
+/** Module structure. */
+struct module_struct {
+	/** Module task identifier if running. */
 	task_id_t task_id;
-	/** Module service identifier.
-	 */
+	/** Module service identifier. */
 	services_t service;
-	/** Module phone if running and connected.
-	 */
+	/** Module phone if running and connected. */
 	int phone;
-	/** Usage counter.
-	 */
+	/** Usage counter. */
 	int usage;
-	/** Module name.
-	 */
-	const char * name;
-	/** Module full path filename.
-	 */
-	const char * filename;
-	/** Connecting function.
-	 */
-	connect_module_t * connect_module;
+	/** Module name. */
+	const char *name;
+	/** Module full path filename. */
+	const char *filename;
+	/** Connecting function. */
+	connect_module_t *connect_module;
 };
 
-/** Adds module to the module map.
- *  @param[out] module The module structure added.
- *  @param[in] modules The module map.
- *  @param[in] name The module name.
- *  @param[in] filename The full path filename.
- *  @param[in] service The module service.
- *  @param[in] task_id The module current task identifier. Zero (0) means not running.
- *  @param[in] connect_module The module connecting function.
- *  @returns EOK on success.
- *  @returns ENOMEM if there is not enough memory left.
- */
-int add_module(module_ref * module, modules_ref modules, const char * name, const char * filename, services_t service, task_id_t task_id, connect_module_t * connect_module);
-
-/** Searches and returns the specified module.
- *  If the module is not running, the module filaname is spawned.
- *  If the module is not connected, the connect_function is called.
- *  @param[in] modules The module map.
- *  @param[in] name The module name.
- *  @returns The running module found. It does not have to be connected.
- *  @returns NULL if there is no such module.
- */
-module_ref get_running_module(modules_ref modules, char * name);
-
-/** Starts the given module.
- *  @param[in] fname The module full or relative path filename.
- *  @returns The new module task identifier on success.
- *  @returns 0 if there is no such module.
- */
-task_id_t spawn(const char * fname);
+extern int add_module(module_ref *, modules_ref, const char *, const char *,
+    services_t, task_id_t, connect_module_t *);
+extern module_ref get_running_module(modules_ref, char *);
+extern task_id_t spawn(const char *);
 
 #endif
Index: uspace/lib/net/include/arp_interface.h
===================================================================
--- uspace/lib/net/include/arp_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/arp_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,90 +27,33 @@
  */
 
-/** @addtogroup arp
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
-#ifndef __NET_ARP_INTERFACE_H__
-#define __NET_ARP_INTERFACE_H__
+#ifndef LIBNET_ARP_INTERFACE_H_
+#define LIBNET_ARP_INTERFACE_H_
 
 #include <adt/measured_strings.h>
-#include <net_device.h>
+#include <task.h>
+
+#include <ipc/services.h>
+
+#include <net/device.h>
+#include <net/socket.h>
 
 /** @name ARP module interface
- *  This interface is used by other modules.
+ * This interface is used by other modules.
  */
 /*@{*/
 
-/** Registers the new device and the requesting protocol service.
- *  Connects to the network interface layer service.
- *  Determines the device broadcast address, its address lengths and packet size.
- *  @param[in] arp_phone The ARP module phone used for (semi)remote calls.
- *  @param[in] device_id The new device identifier.
- *  @param[in] protocol The requesting protocol service.
- *  @param[in] netif The underlying device network interface layer service.
- *  @param[in] address The local requesting protocol address of the device.
- *  @returns EOK on success.
- *  @returns EEXIST if the device is already used.
- *  @returns ENOMEM if there is not enough memory left.
- *  @returns ENOENT if the network interface service is not known.
- *  @returns EREFUSED if the network interface service is not responding.
- *  @returns Other error codes as defined for the nil_packet_get_size() function.
- *  @returns Other error codes as defined for the nil_get_addr() function.
- *  @returns Other error codes as defined for the nil_get_broadcast_addr() function.
- */
-extern int arp_device_req(int arp_phone, device_id_t device_id, services_t protocol, services_t netif, measured_string_ref address);
-
-/** Translates the given protocol address to the network interface address.
- *  Broadcasts the ARP request if the mapping is not found.
- *  Allocates and returns the needed memory block as the data parameter.
- *  @param[in] arp_phone The ARP module phone used for (semi)remote calls.
- *  @param[in] device_id The device identifier.
- *  @param[in] protocol The requesting protocol service.
- *  @param[in] address The local requesting protocol address.
- *  @param[out] translation The translation of the local protocol address.
- *  @param[out] data The allocated raw translation data container.
- *  @returns EOK on success.
- *  @returns EINVAL if the address parameter is NULL.
- *  @returns EBADMEM if the translation or the data parameters are NULL.
- *  @returns ENOENT if the mapping is not found.
- */
-extern int arp_translate_req(int arp_phone, device_id_t device_id, services_t protocol, measured_string_ref address, measured_string_ref * translation, char ** data);
-
-/** Clears the device cache.
- *  @param[in] arp_phone The ARP module phone used for (semi)remote calls.
- *  @param[in] device_id The device identifier.
- *  @returns EOK on success.
- *  @returns ENOENT if the device is not found.
- */
-extern int arp_clear_device_req(int arp_phone, device_id_t device_id);
-
-/** Clears the given protocol address from the cache.
- *  @param[in] arp_phone The ARP module phone used for (semi)remote calls.
- *  @param[in] device_id The device identifier.
- *  @param[in] protocol The requesting protocol service.
- *  @param[in] address The protocol address to be cleared.
- *  @returns EOK on success.
- *  @returns ENOENT if the mapping is not found.
- */
-extern int arp_clear_address_req(int arp_phone, device_id_t device_id, services_t protocol, measured_string_ref address);
-
-/** Cleans the cache.
- *  @param[in] arp_phone The ARP module phone used for (semi)remote calls.
- *  @returns EOK on success.
- */
-extern int arp_clean_cache_req(int arp_phone);
-
-/** Connects to the ARP module.
- *  @param service The ARP module service. Ignored parameter.
- *  @returns The ARP module phone on success.
- *  @returns 0 if called by the bundle module.
- */
-extern int arp_connect_module(services_t service);
-
-/** Returns the ARP task identifier.
- *  @returns The current task identifier if called by the bundle module.
- *  @returns 0 if called by the remote module.
- */
-extern task_id_t arp_task_get_id(void);
+extern int arp_device_req(int, device_id_t, services_t, services_t,
+    measured_string_ref);
+extern int arp_translate_req(int, device_id_t, services_t, measured_string_ref,
+    measured_string_ref *, char **);
+extern int arp_clear_device_req(int, device_id_t);
+extern int arp_clear_address_req(int, device_id_t, services_t,
+    measured_string_ref);
+extern int arp_clean_cache_req(int);
+extern int arp_connect_module(services_t);
 
 /*@}*/
Index: uspace/lib/net/include/generic.h
===================================================================
--- uspace/lib/net/include/generic.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/net/include/generic.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnet
+ * @{
+ */
+
+/** @file
+ * Generic communication interfaces for networking.
+ */
+
+#ifndef LIBNET_GENERIC_H_
+#define LIBNET_GENERIC_H_
+
+#include <async.h>
+#include <ipc/ipc.h>
+#include <ipc/services.h>
+
+#include <net/device.h>
+#include <adt/measured_strings.h>
+#include <net/packet.h>
+
+extern int generic_device_state_msg_remote(int, int, device_id_t, int,
+    services_t);
+extern int generic_device_req_remote(int, int, device_id_t, int, services_t);
+extern int generic_get_addr_req(int, int, device_id_t, measured_string_ref *,
+    char **);
+extern int generic_packet_size_req_remote(int, int, device_id_t,
+    packet_dimension_ref);
+extern int generic_received_msg_remote(int, int, device_id_t, packet_id_t,
+    services_t, services_t);
+extern int generic_send_msg_remote(int, int, device_id_t, packet_id_t,
+    services_t, services_t);
+extern int generic_translate_req(int, int, device_id_t, services_t,
+    measured_string_ref, size_t, measured_string_ref *, char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/net/include/icmp_client.h
===================================================================
--- uspace/lib/net/include/icmp_client.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/icmp_client.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -38,6 +38,6 @@
 #define __NET_ICMP_CLIENT_H__
 
-#include <icmp_codes.h>
-#include <packet/packet.h>
+#include <net/icmp_codes.h>
+#include <net/packet.h>
 
 /** Processes the received packet prefixed with an ICMP header.
Index: uspace/lib/net/include/icmp_header.h
===================================================================
--- uspace/lib/net/include/icmp_header.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/icmp_header.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,6 +41,6 @@
 #include <sys/types.h>
 
-#include <in.h>
-#include <icmp_codes.h>
+#include <net/in.h>
+#include <net/icmp_codes.h>
 
 /** ICMP header size in bytes.
Index: uspace/lib/net/include/icmp_interface.h
===================================================================
--- uspace/lib/net/include/icmp_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/icmp_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,14 +34,14 @@
 #define __NET_ICMP_INTERFACE_H__
 
+#include <net/socket_codes.h>
 #include <sys/types.h>
 
-#include <net_device.h>
+#include <net/device.h>
 #include <adt/measured_strings.h>
-#include <packet/packet.h>
-#include <inet.h>
-#include <ip_codes.h>
-#include <socket_codes.h>
-#include <icmp_codes.h>
-#include <icmp_common.h>
+#include <net/packet.h>
+#include <net/inet.h>
+#include <net/ip_codes.h>
+#include <net/icmp_codes.h>
+#include <net/icmp_common.h>
 
 /** @name ICMP module interface
Index: uspace/lib/net/include/il_interface.h
===================================================================
--- uspace/lib/net/include/il_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/il_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -39,13 +39,13 @@
 #define __NET_IL_INTERFACE_H__
 
-#include <async.h>
+#include <generic.h>
 
 #include <ipc/services.h>
+#include <ipc/il.h>
 
-#include <net_messages.h>
-#include <net_device.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <il_messages.h>
+#include <net/device.h>
+#include <net/packet.h>
+
+#include <packet_client.h>
 
 /** @name Internetwork layer module interface
Index: uspace/lib/net/include/ip_client.h
===================================================================
--- uspace/lib/net/include/ip_client.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/ip_client.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,85 +27,30 @@
  */
 
-/** @addtogroup ip
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  IP client interface.
+ * IP client interface.
  */
 
-#ifndef __NET_IP_CLIENT_H__
-#define __NET_IP_CLIENT_H__
+#ifndef LIBNET_IP_CLIENT_H_
+#define LIBNET_IP_CLIENT_H_
 
+#include <net/socket_codes.h>
 #include <sys/types.h>
 
-#include <packet/packet.h>
-#include <ip_codes.h>
+#include <net/packet.h>
+#include <net/ip_codes.h>
 #include <ip_interface.h>
-#include <socket_codes.h>
 
-/** Prepares the packet to be transfered via IP.
- *  The IP header is prefixed.
- *  @param[in,out] packet The packet to be prepared.
- *  @param[in] protocol The transport protocol.
- *  @param[in] ttl The time to live counter. The IPDEFTTL is set if zero (0).
- *  @param[in] tos The type of service.
- *  @param[in] dont_fragment The value indicating whether fragmentation is disabled.
- *  @param[in] ipopt_length The prefixed IP options length in bytes.
- *  @returns EOK on success.
- *  @returns ENOMEM if there is not enough memory left in the packet.
- */
-extern int ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl, ip_tos_t tos, int dont_fragment, size_t ipopt_length);
-
-/** Processes the received IP packet.
- *  Fills set header fields.
- *  Returns the prefixed IP header length.
- *  @param[in] packet The received packet.
- *  @param[out] protocol The transport protocol. May be NULL if not desired.
- *  @param[out] ttl The time to live counter. May be NULL if not desired.
- *  @param[out] tos The type of service. May be NULL if not desired.
- *  @param[out] dont_fragment The value indicating whether the fragmentation is disabled. May be NULL if not desired.
- *  @param[out] ipopt_length The IP options length in bytes. May be NULL if not desired.
- *  @returns The prefixed IP header length in bytes on success.
- *  @returns ENOMEM if the packet is too short to contain the IP header.
- */
-extern int ip_client_process_packet(packet_t packet, ip_protocol_t * protocol, ip_ttl_t * ttl, ip_tos_t * tos, int * dont_fragment, size_t * ipopt_length);
-
-/** Returns the IP header length.
- *  @param[in] packet The packet.
- *  @returns The IP header length in bytes.
- *  @returns Zero (0) if there is no IP header.
- */
-extern size_t ip_client_header_length(packet_t packet);
-
-/** Updates the IPv4 pseudo header data length field.
- *  @param[in,out] header The IPv4 pseudo header to be updated.
- *  @param[in] headerlen The length of the IP pseudo header in bytes.
- *  @param[in] data_length The data length to be set.
- *  @returns EOK on success.
- *  @returns EBADMEM if the header parameter is NULL.
- *  @returns EINVAL if the headerlen parameter is not IPv4 pseudo header length.
- */
-extern int ip_client_set_pseudo_header_data_length(void *header, size_t headerlen, size_t data_length);
-
-/** Constructs the IPv4 pseudo header.
- *  @param[in] protocol The transport protocol.
- *  @param[in] src The source address.
- *  @param[in] srclen The source address length.
- *  @param[in] dest The destination address.
- *  @param[in] destlen The destination address length.
- *  @param[in] data_length The data length to be set.
- *  @param[out] header The constructed IPv4 pseudo header.
- *  @param[out] headerlen The length of the IP pseudo header in bytes.
- *  @returns EOK on success.
- *  @returns EBADMEM if the header and/or the headerlen parameter is NULL.
- *  @returns EINVAL if the source address and/or the destination address parameter is NULL.
- *  @returns EINVAL if the source address length is less than struct sockaddr length.
- *  @returns EINVAL if the source address length differs from the destination address length.
- *  @returns EINVAL if the source address family differs from the destination family.
- *  @returns EAFNOSUPPORT if the address family is not supported.
- *  @returns ENOMEM if there is not enough memory left.
- */
-extern int ip_client_get_pseudo_header(ip_protocol_t protocol, struct sockaddr * src, socklen_t srclen, struct sockaddr * dest, socklen_t destlen, size_t data_length, void **header, size_t * headerlen);
+extern int ip_client_prepare_packet(packet_t, ip_protocol_t, ip_ttl_t, ip_tos_t,
+    int, size_t);
+extern int ip_client_process_packet(packet_t, ip_protocol_t *, ip_ttl_t *,
+    ip_tos_t *, int *, size_t *);
+extern size_t ip_client_header_length(packet_t);
+extern int ip_client_set_pseudo_header_data_length(void *, size_t, size_t);
+extern int ip_client_get_pseudo_header(ip_protocol_t, struct sockaddr *,
+    socklen_t, struct sockaddr *, socklen_t, size_t, void **, size_t *);
 
 // TODO ipopt manipulation
